Global( "TextName", {} )
Global( "TextDamage", {} )
Global( "TextPos", {} )
Global( "PPerDamage", {} )
Global( "PUnit", {} )
Global( "PMain", {} )
Global( "DUnit", {} )
Global( "DUnitf", {} )
Global( "DUnits", {} )
Global( "Container", {} )
Global( "ConCon", 0 )
--
Global( "Lastparams", nil )
Global( "LastFght", 1 )
Global( "LastSpell", 1 )
Global( "FSpells", {})

--==--
function SetHisMode (name)
if name == "Fight_Damage_Done" then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_UNITS
elseif name == "Damage_Done" then
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_UNITS
elseif name == "Fight_Damage_Taken" then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_ENEMIES
elseif name == "Damage_Taken" then
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_ENEMIES
elseif name == "Fight_Healing_Done"then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_HEALERS
elseif name == "Healing_Done" then
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_HEALERS
elseif name == "Fight_Healing_Taken" then
	Battle.cnf.fighis = true
	Battle.cnf.curtable = TABLE_HEAL
else
	Battle.cnf.fighis = false
	Battle.cnf.curtable = TABLE_HEAL
end
Container[2]:GetParent():GetChildUnchecked("PanelHeader", false):GetChildUnchecked("TextHeader", false):SetVal("Mode", GetTextLocalized(GetHisMode()))
end

function GetHisMode ()
if Battle.cnf.curtable == TABLE_UNITS then
	return Battle.cnf.fighis and "Fight_Damage_Done" or "Damage_Done"
elseif Battle.cnf.curtable == TABLE_ENEMIES then
	return Battle.cnf.fighis and "Fight_Damage_Taken" or "Damage_Taken"
elseif Battle.cnf.curtable == TABLE_HEALERS then
	return Battle.cnf.fighis and "Fight_Healing_Done" or "Healing_Done"
else--if Battle.cnf.curtable == TABLE_ENEMIES then
	return Battle.cnf.fighis and "Fight_Healing_Taken" or "Healing_Taken"
end
end

function SetVisMode (name)
if name == "Damage" then Battle.cnf.curvis = V_DAMAGE
elseif name == "Heal" then Battle.cnf.curvis = V_HEAL
elseif name == "DpS" then Battle.cnf.curvis = V_DPS
else --name == "HpS" then
	Battle.cnf.curvis = V_HPS
end
PMain[1]:SetVal("Name", GetTextLocalized(GetVisMode()))
end

function GetVisMode ()
if Battle.cnf.curvis == V_DAMAGE then return "Damage"
elseif Battle.cnf.curvis == V_HEAL then return "Heal"
elseif Battle.cnf.curvis == V_DPS then return "DpS"
else--if Battle.cnf.curvis == V_HPS then
	return "HpS"
end
end

function GetTextLocalized (strText)
return LStr[Lclz][strText] and userMods.ToWString(tostring(LStr[Lclz][strText])) or common.GetEmptyWString()
end

function GetGameLocalization()
	if not avatar.GetEmotes then return "eng" end -- AO 1.1.00
	return ({["\255"] ="rus", ["\108"] ="eng", ["\105"] ="ger", ["\114"] ="fra"})
	 [string.sub(userMods.FromWString(cartographer.GetMapBlockInfo(cartographer.GetMapBlocks()[4] ).name),3,3)] or "eng"
end
function CheckVer ()
if not unit.IsDead then
	if not social.GetFriendInfo then return 1103
	else return 1104 end
elseif not common.SetGlobalConfigSection then return 1102
elseif avatar.GetEmotes then return 1101
end
return 1100
end

function Config (csave)
if csave then
	if CheckVer() < 1102 then
		common.SetGlobalConfigSection("Battle"..revision, Battle.cnf)
	else
		userMods.SetGlobalConfigSection("Battle"..revision, Battle.cnf)
	end
else
	local btl = {}
	if CheckVer() < 1102 then
		btl = common.GetGlobalConfigSection("Battle"..revision)
	else
		btl = userMods.GetGlobalConfigSection("Battle"..revision)
	end
	if btl and btl.curtable then Battle.cnf = btl end
end
end

function GoSleep (gsleep)
Battle.cnf.freeze = gsleep
PMain[1]:GetParent():Show(not gsleep)
PUnit[1]:Show(not gsleep)
if gsleep then
	PMain[2]:GetParent():GetChildUnchecked("BtnUpDn", false):SetVariant(0)
	mainForm:GetChildUnchecked("PanelGroup", false):Show(false)
	local pos = DnD.wtMovable:GetPlacementPlain()
	pos.posX, pos.posY = 40, 65
	DnD.wtMovable:SetPlacementPlain(pos)
else
	DnDReg ()
end
Config (true)
end

function RefrVisData ()
local tbl, pos, pg = {}, 0, mainForm:GetChildUnchecked("PanelGroup", false)
local tbl, ftbl = GetCurGroupDPS(TABLE_UNITS), GetCurDPS(TABLE_UNITS)
--local tbl, ftbl = GetCurGroupDPS(Battle.cnf.curtable), GetCurDPS(Battle.cnf.curtable)

if ConCon > table.getn(tbl) then
	ConCon = 0
	Container[1]:RemoveItems()
end

for v,t in tbl do
	if t[1] == Battle.avaid then
		TextName[1]:SetVal("Pos", Format02d(v))
		TextName[1]:SetVal("Name", t[3])
		TextDamage[1]:SetVal("Damage", Format45d(t[2]))
		TextDamage[1]:SetVal("DPS", Format45d(t[5]))
		TextPos[1]:SetVal("Pers", Format02d(t[6]))
		pos = PPerDamage[1]:GetPlacementPlain()
		pos.sizeX = 3.3 * t[6]
		PPerDamage[1]:SetPlacementPlain(pos)
		PPerDamage[1]:SetBackgroundColor(t[4])
		PPerDamage[1]:GetParent():SetBackgroundColor(t[4])
		break
	end
end

if pg:IsVisible() --[[and Battle.dmge]] then
	for i,t in tbl do
		TextName[i+1]:SetVal("Pos", Format02d(i))
		TextName[i+1]:SetVal("Name", t[3])
		TextDamage[i+1]:SetVal("Damage", Format45d(t[2]))
		TextDamage[i+1]:SetVal("DPS", Format45d(t[5]))
		TextPos[i+1]:SetVal("Pers", Format02d(t[6]))
		pos = PPerDamage[i+1]:GetPlacementPlain()
		pos.sizeX = 3.3 * t[6]
		PPerDamage[i+1]:SetPlacementPlain(pos)
		PPerDamage[i+1]:GetParent():SetBackgroundColor(t[4])
		PPerDamage[i+1]:SetBackgroundColor(t[4])
		if ConCon < i then
			Container[1]:PushBack(PUnit[i+1])
			ConCon  = i
		end
		
	end
end

--if ftbl[5] then PMain[1]:SetVal("Name", ftbl[5]) end
PMain[2]:SetVal("Damage", Format45d(ftbl[1]))
PMain[2]:SetVal("DPS", Format45d(ftbl[2]))
PMain[3]:SetVal("Min", Format02d(ftbl[3]))
PMain[3]:SetVal("Sec", Format02d(ftbl[4]))

pos = pg:GetPlacementPlain()
tbl = table.getn(tbl)
tbl = tbl < MaxUnits and tbl or MaxUnits
tbl = tbl > MinUnits and tbl or MinUnits

pos.sizeY = 21 * tbl
pg:SetPlacementPlain(pos)
end

function CreateWidgets()
--[[
Panels
[1] - avatars PanelUnit
[2]..[7] - Group PanelUnit

Containers
[1] - Group
[2] - Fights Names
[3] - Fights Units
[4] - Unit Spells
]]
local pos
local wdt = {}
---PanelUnit
PUnit[1] = mainForm:GetChildUnchecked("PanelUnit", false)
PPerDamage[1] = PUnit[1]:GetChildUnchecked("PanelPers", false)
TextDamage[1] = PUnit[1]:GetChildUnchecked("TextDPS", false)
TextName[1] = PUnit[1]:GetChildUnchecked("TextName", false)
TextPos[1] = PUnit[1]:GetChildUnchecked("TextPers", false)

--PanelGroup
wdt[1] = mainForm:GetChildUnchecked("PanelGroup", false)
wdt[2] = PUnit[1]:GetWidgetDesc()
for i = 2, 25 do
	PUnit[i] = mainForm:CreateWidgetByDesc(wdt[2])
	mainForm:GetChildUnchecked("PanelDetail", false):AddChild(PUnit[i])
	PPerDamage[i] = PUnit[i]:GetChildUnchecked("PanelPers", false)
	TextDamage[i] = PUnit[i]:GetChildUnchecked("TextDPS", false)
	TextName[i] = PUnit[i]:GetChildUnchecked("TextName", false)
	TextPos[i] = PUnit[i]:GetChildUnchecked("TextPers", false)
end
Container[1] = wdt[1]:GetChildUnchecked("ContainerGroup", false)

--PanelMain
wdt[1] = mainForm:GetChildUnchecked("PanelMain", false)
PMain[1] = wdt[1]:GetChildUnchecked("TextBN", false)
PMain[2] = wdt[1]:GetChildUnchecked("TextBDPS", false)
PMain[3] = wdt[1]:GetChildUnchecked("TextBTime", false)

--Containers
wdt[1] = mainForm:GetChildUnchecked("PanelDetail", false)
Container[2] = wdt[1]:GetChildUnchecked("Container", false)
wdt[2] = Container[2]:GetWidgetDesc()

Container[3] = mainForm:CreateWidgetByDesc(wdt[2])
wdt[1]:AddChild(Container[3])
pos = Container[2]:GetPlacementPlain()
pos.posY, pos.sizeY = 130, 130
Container[3]:SetPlacementPlain(pos)

Container[4] = mainForm:CreateWidgetByDesc(wdt[2])
wdt[1]:AddChild(Container[4])
pos = Container[2]:GetPlacementPlain()
pos.posY, pos.sizeY = 280, 110
Container[4]:SetPlacementPlain(pos)

--DUnit
DUnit[1] = wdt[1]:GetChildUnchecked("PanelDBUnit", false)
DUnits[1] = wdt[1]:GetChildUnchecked("PanelSpell", false)
DUnits[1]:SetName("PnlS_1")
wdt[1]:GetChildUnchecked("TextAddon", false):Show(true)


--History menu
wdt[1] = mainForm:GetChildUnchecked("PanelSelect", false)
wdt[3] = {
	"Fight_Damage_Done",
	"Fight_Damage_Taken",
	"Fight_Healing_Done",
	"Fight_Healing_Taken",
	"Damage_Done",
	"Damage_Taken",
	"Healing_Done",
	"Healing_Taken",
	"Reset"
}
pos = wdt[1]:GetPlacementPlain()
pos.sizeY = table.getn(wdt[3]) * 20 + 30
wdt[1]:SetPlacementPlain(pos)
wdt[1] = wdt[1]:GetChildUnchecked("BtnSlct", false)
wdt[1]:SetName(wdt[3][1])
wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][1]))
wdt[2] = wdt[1]:GetWidgetDesc()
pos = wdt[1]:GetPlacementPlain()
for i=2, table.getn(wdt[3]) do
	wdt[1] = mainForm:CreateWidgetByDesc(wdt[2])
	mainForm:GetChildUnchecked("PanelSelect", false):AddChild(wdt[1])
	pos.posY = i * 20 - 5
	wdt[1]:SetPlacementPlain(pos)
	wdt[1]:SetName(wdt[3][i])
	wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][i]))
end

--Curren fight menu
wdt[3] = wdt[1]:GetParent():GetWidgetDesc()
wdt[1] = mainForm:CreateWidgetByDesc(wdt[3])
wdt[1]:SetName("CFMenu")
wdt[3] = {
	"Damage",
	"Heal",
	"DpS",
	"HpS"
}
pos = wdt[1]:GetPlacementPlain()
pos.sizeY = table.getn(wdt[3]) * 20 + 30
pos.sizeX = 200
wdt[1]:SetPlacementPlain(pos)
wdt[1] = wdt[1]:GetChildUnchecked("BtnSlct", false)
wdt[1]:SetName(wdt[3][1])
wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][1]))
pos = wdt[1]:GetPlacementPlain()
for i=2, table.getn(wdt[3]) do
	wdt[1] = mainForm:CreateWidgetByDesc(wdt[2])
	mainForm:GetChildUnchecked("CFMenu", false):AddChild(wdt[1])
	pos.posY = i * 20 - 5
	wdt[1]:SetPlacementPlain(pos)
	wdt[1]:SetName(wdt[3][i])
	wdt[1]:SetVal("Value",GetTextLocalized(wdt[3][i]))
end
end

function PlaceSDetail (snum)
if LastSpell == snum then return end
if not FSpells then return end
mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelTimes", false):Show(false)
local pnlSD = mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelSDetail", false)
pnlSD:Show(true)
LastSpell = snum
pnlSD = pnlSD:GetNamedChildren()
local tbl = FSpells[snum]
if not tbl or (not tbl[1]) then return end
for v,t in pnlSD do
	if t:GetName() == "TextSAdd" then
		t:SetVal("Name",tbl[2])
	elseif t:GetName() == "TextSAdd1" then
		t:SetVal("Max",Format45d(tbl[6]))
		t:SetVal("Mid",Format45d(tbl[7]))
		t:SetVal("Min",Format45d(tbl[8]))
		t:SetVal("Crit",Format02d(tbl[9]))
		t:SetVal("Glans",Format02d(tbl[10]))
	elseif t:GetName() == "TextSAdd2" then
		t:SetVal("Lost",Format45d(tbl[17]))
		t:SetVal("Perlost",Format02d(tbl[18]))
		t:SetVal("Resist",Format45d(tbl[15]))
		t:SetVal("Absorb",Format45d(tbl[16]))
	elseif t:GetName() == "TextSAdd3" then
		t:Show(Battle.cnf.curtable < TABLE_HEALERS)
		if Battle.cnf.curtable < TABLE_HEALERS then
			t:SetVal("ShB",Format45d(tbl[13]))
			t:SetVal("Parry",Format45d(tbl[14]))
			t:SetVal("Miss",Format02d(tbl[11]))
			t:SetVal("Dodge",Format02d(tbl[12]))
		end
	end
end
end

function PlaceSpells (unum)
Container[4]:RemoveItems()
local wdt, wdt2, pos = DUnits[1]:GetWidgetDesc()
if Battle.cnf.fighis then
	Container[2]:GetParent():GetChildUnchecked("TextFiD", false):SetVal("Figr", L_units[Fights[LastFght].db[Battle.cnf.curtable].tUnits[unum].myid].uName)
	FSpells = GetUnitSpells(GetRequest("ONE"),unum)
else
	FSpells = GetUnitSpells(GetRequest("ALL"),unum)
	Container[2]:GetParent():GetChildUnchecked("TextFiD", false):SetVal("Figr", L_units[unum].uName)
end
if not FSpells then return end
for v, t in FSpells do
	if not DUnits[v] then
		DUnits[v] = mainForm:CreateWidgetByDesc(wdt)
		DUnits[v]:SetName("PnlS_"..v)
	end
	wdt2 = DUnits[v]:GetNamedChildren()
	for u,p in wdt2 do
		if p:GetName() == "TextSName" then
			p:SetVal("Name", t[2])
		elseif p:GetName() == "TextSDPS" then
			p:SetVal("Damage", Format45d(t[1]))
			p:SetVal("Cnt", Format02d(t[5]))
		elseif p:GetName() == "TextSPers" then
			p:SetVal("Pers", Format02d(t[4]))
		elseif p:GetName() == "PanelPers" then
			p:SetBackgroundColor(t[3])
			pos = p:GetPlacementPlain()
			pos.sizeX = 3.3 * t[4]
			p:SetPlacementPlain(pos)
		end
	end
Container[4]:PushBack(DUnits[v])
end
LastSpell = 0
end

function PlaceFighters (fnum)
local wdt, pos, tbl, dam = DUnit[1]:GetWidgetDesc()
Container[3]:RemoveItems()

if Battle.cnf.fighis then
	Container[3]:GetParent():GetChildUnchecked("TextFiD", false):SetVal("Pos", Format02d(1+table.getn(Fights)-fnum))
	Container[3]:GetParent():GetChildUnchecked("TextFiD", false):SetVal("Fig", Fights[fnum].fName)
	tbl = GetGroupDPS(Battle.cnf.curtable,fnum)
else
	tbl, dam = GetAllUnits(Battle.cnf.curtable)
	Container[3]:GetParent():GetChildUnchecked("TextFiD", false):ClearValues()
end

if not tbl or (not tbl[1]) then
	if not Battle.cnf.fighis then Container[2]:RemoveItems() end
	Container[4]:RemoveItems()
	return
end

for v, t in tbl do
	if not DUnitf[v] then
		DUnitf[v] = mainForm:CreateWidgetByDesc(wdt)
	end
	for u,p in DUnitf[v]:GetNamedChildren() do
		if p:GetName() == "TextDBName" then
			p:SetVal("Pos", Format02d(v))
			p:SetVal("Name", t[1])
		elseif p:GetName() == "TextDBDPS" then
			p:SetVal("Damage", Format45d(t[2]))
			p:SetVal("DPS", Format45d(t[5]))
		elseif p:GetName() == "TextDBTime" then
			if not Battle.cnf.fighis then
				p:SetVal("Sec", Format02d(t[7]))
			else
				p:ClearValues()
			end
			p:SetVal("Min", Format02d(t[6]))
		elseif p:GetName() == "PanelPers" then
			p:SetBackgroundColor(t[4])
			pos = p:GetPlacementPlain()
			if Battle.cnf.fighis then
				pos.sizeX = 3.3 * t[6]
			else
				pos.sizeX = 330 * t[2]/dam
			end
			p:SetPlacementPlain(pos)
		elseif string.find(p:GetName(),"Btn") then
		if Battle.cnf.fighis then
			p:SetName("BtnD_"..tostring(v))
		else
			p:SetName("BtnD_"..tostring(t[3]))
		end
	end
end
Container[3]:PushBack(DUnitf[v])
end


if Battle.cnf.fighis then
	LastFght = fnum
	PlaceTimes(LastFght)
	PlaceSpells (1)
else
--common.LogInfo(common.GetAddonName(),"tbl[1][3]", Format45d(tbl[1][3]))
PlaceFights (tbl[1][3])
PlaceSpells (tbl[1][3])
end
end

function PlaceTimes (fnum)
--common.LogInfo(common.GetAddonName(),"PlaceTimes", Format45d(fnum))
mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelSDetail", false):Show(false)
local wdt = mainForm:GetChildUnchecked("PanelDetail", false):GetChildUnchecked("PanelTimes", false)
local tbl = Fights[fnum].ftime_unit
wdt:Show(true)
wdt = wdt:GetNamedChildren()
	for v,t in wdt do
		if t:GetName() == "TextTime1" then
			t:SetVal("Thh", Format02d(tbl[1]))
			t:SetVal("Tmm", Format02d(tbl[2]))
			t:SetVal("Tss", Format02d(tbl[3]))
			t:SetVal("Name", L_units[tbl[7]].uName)
			t:SetVal("Spell", tbl[9])
		elseif t:GetName() == "TextTime2" then
			t:SetVal("Thh", Format02d(tbl[4]))
			t:SetVal("Tmm", Format02d(tbl[5]))
			t:SetVal("Tss", Format02d(tbl[6]))
			t:SetVal("Name", L_units[tbl[8]].uName)
			t:SetVal("Spell", tbl[10])
		end
	end
end

function PlaceFights (uin)
--common.LogInfo(common.GetAddonName(),"uin - ", Format02d(uin))
local wdt, wdt2,mn,sc, tbl, dam = DUnit[1]:GetWidgetDesc()
Container[2]:RemoveItems()
--Container[2]:GetParent():GetChildUnchecked("PanelHeader", false):GetChildUnchecked("TextTime", false):ClearValues()
if Battle.cnf.fighis then
	tbl = GetFights (Battle.cnf.curtable)
else
	tbl, dam = GetAllUnFights(Battle.cnf.curtable, uin)
	--Container[2]:GetParent():GetChildUnchecked("PanelHeader", false):GetChildUnchecked("TextTime", false):SetVal("Dmg", Format45d(dam))
end
if not tbl or (not tbl[1]) then
	if Battle.cnf.fighis then Container[3]:RemoveItems() end
	return
end
for v,t in tbl do
	if not DUnit[v] then
		DUnit[v] = mainForm:CreateWidgetByDesc(wdt)
	end
	wdt2 = DUnit[v]:GetNamedChildren()
	for u,p in wdt2 do
		if p:GetName() == "TextDBName" then
			p:SetVal("Pos", Format02d(table.getn(tbl)-v+1))
			p:SetVal("Name", t[1])
		elseif p:GetName() == "TextDBDPS" then
			if not t[3] then
				common.LogInfo(common.GetAddonName(),"not t[3]")
			else
			p:SetVal("Damage", Format45d(t[2]))
			p:SetVal("DPS", Format45d(t[4]))
			end

		elseif p:GetName() == "TextDBTime" then
			mn,sc = GetMinSec(t[3])
			p:SetVal("Min", Format02d(mn))
			p:SetVal("Sec", Format02d(sc))
			elseif string.find(p:GetName(),"Btn") then
			if Battle.cnf.fighis then
				p:SetName("BtnDU_"..tostring(v))
			else
				p:SetName("BtnFD_"..tostring(v))
			end
		end
	end
Container[2]:PushBack(DUnit[v])
end
if Battle.cnf.fighis then PlaceFighters (uin) end
PlaceTimes(1)
end

function DataInit ()
if avatar.IsExist() then
	VRefresh = (VRefresh < 1) and 1 or VRefresh
	MaxUnits = (MaxUnits < 3) and 3 or ((MaxUnits > 20) and 20 or MaxUnits)
	MinUnits = (MinUnits < 3) and 3 or ((MinUnits > MaxUnits) and MaxUnits or MinUnits)
	MaxHistory = (MaxHistory < 5) and 5 or MaxHistory
	Config (false)
	Battle.avaid = avatar.GetId()
	mainForm:GetChildUnchecked("PanelGroup", false):Show(Battle.cnf.gropened)
	mainForm:GetChildUnchecked("PanelMain", false):GetChildUnchecked("BtnUpDn", false):SetVariant(Battle.cnf.gropened and 1 or 0)
	GoSleep (Battle.cnf.freeze)
	Resetdata()
	SetHisMode (GetHisMode())
	SetVisMode (GetVisMode())
	end
end

function SaveFightincfg()
userMods.SetGlobalConfigSection("CurFight", Fights[1].db[TABLE_HEALERS])
--userMods.SetGlobalConfigSection("CurFight", Fights[table.getn(Fights)].tUnits)
end

function Init()
if CheckVer() < 1101 then return end
Lclz = "rus" -- 
Reg(EVRe)
CreateWidgets()
mainForm:GetChildUnchecked("BtnFreeze", false):SetVariant(2)

DnDInit()
DataInit()
if CheckVer () < 1104 then mainForm:SetPriority(1500)
else mainForm:SetPriority(5000) end
end

Init()
